library rand;   //       dll,   exe -.  rnd   
uses   SysUtils, Math; //      MSX DLL.    .
{$I MSXStruc.inc}

//*********************************************************
//  .      dll.
//   ,   ,       DLL
function MSXInfo (var a_psDLLDef: MSXDLLDef): LongBool; stdcall; // ,    ,    
begin
  StrLCopy (a_psDLLDef.szCopyright, '  ', MSX_MAXSTRING-1);
  a_psDLLDef.iNFuncs := 1;  //  ,     ,    ,     .     
  a_psDLLDef.iVersion := MSX_VERSION;  //  MSX (MetaStock eXternal).     
  MSXInfo := MSX_SUCCESS;// ,   MSXInfo 
end;

//*********************************************************
//  .      dll.
//    ,     
//          MSXInfo.    .
//    -  (  ).
// ,    ,    
function MSXNthFunction (a_iNthFunc: Integer; var a_psFuncDef: MSXFuncDef): LongBool; stdcall;
  var l_bRtrn : LongBool;
begin
  l_bRtrn := MSX_SUCCESS;
  case a_iNthFunc of //     ?    ,     .
    0: begin//    .     
         StrCopy(a_psFuncDef.szFunctionName, 'Rnd');  //     .        (  )
         StrCopy(a_psFuncDef.szFunctionDescription, 'Returns randomized data');//' . ,  .
         a_psFuncDef.iNArguments := 0; //      
       end;

//        ,      :
//  1: begin
//          StrCopy(a_psFuncDef.szFunctionName, 'Smoother');
//          StrCopy(a_psFuncDef.szFunctionDescription, 'Smooth Out The Noise');
//          a_sFuncDef.iNArguments := 1;
//        end;
    else
      l_bRtrn := MSX_ERROR; //      .
  end;
  MSXNthFunction := l_bRtrn;//         (   )
end;





//*********************************************************
//  .      dll.
//    "" ,        
//      ,        
function MSXNthArg(a_iNthFunc: Integer; a_iNthArg: Integer;
                   var a_psFuncArgDef: MSXFuncArgDef): LongBool; stdcall;
  var l_bRtrn : LongBool;
begin
  l_bRtrn := MSX_SUCCESS;
  a_psFuncArgDef.iNCustomStrings := 0;  // ,   ,    ,     
  MSXNthArg := l_bRtrn;
end;



//********************************************
// ,   ()      
//
//********************************************
// ,    DLL                   .   ....
function Rnd (const a_psDataRec: PMSXDataRec;//         security    
                    const a_psDataInfoArgs: PMSXDataInfoRecArgsArray;//        ,   ,   .     ,      
                    const a_psNumericArgs: PMSXNumericArgsArray; //   ,       
                    const a_psStringArgs: PMSXStringArgsArray;  //  ..
                    const a_psCustomArgs: PMSXCustomArgsArray;  //  ..
                    var a_psResultRec: MSXResultRec): LongBool; stdcall; //     longbool.

 var  l_iIndex   : Integer;//        .          .
      l_iMaxIndex: Integer;//        .
      i          : Integer; //    
      l_bRtrn    : LongBool;//     ,  ,     (.. true)   
begin
  l_bRtrn := MSX_SUCCESS; //..       ,    

//.    ,           sOpen      
//  sOpen  sClose sVol  ..    
  l_iIndex := a_psDataRec.sOpen.iFirstValid;
  l_iMaxIndex := a_psDataRec.sOpen.iLastValid;
  randomize;//""   
          if l_iMaxIndex >= l_iIndex then  //       ...
            for i:= l_iIndex to l_iMaxIndex do //""   ...
              a_psResultRec.psResultArray.pfValue[i] :=random;//        0  1

  Rnd := l_bRtrn;//     MSX_SUCCESS, .. 
end;









//*************************************************
//       . ,    ,   .     ,      ,     
//*************************************************
exports
 MSXInfo, //    ,       dll
 MSXNthFunction, //    ,       dll
 MSXNthArg, //    ,       dll
 Rnd;//    
//.      

begin
//     
end.

